/*	$Id: exec.c,v 1.1 1999/12/07 04:08:04 leonard Exp $	*/
/* Copyright 1999, David Leonard. All rights reserved */

#include <stdio.h>
#include <unistd.h>
#include <err.h>
#include <paths.h>

#include <sys/types.h>
#include <sys/wait.h>

#include "vox.h"
#include "exec.h"

/*
 * Run an external command with the modem on stdin/stdout
 */
void
do_exec(cmd)
	char *cmd;
{
	pid_t pid;
	int status;

	pid = fork();
	if (pid == -1) {
		warn("fork");
		return;
	}
	if (pid == 0) {
		dup2(modemfd, STDIN_FILENO);
		dup2(modemfd, STDOUT_FILENO);
		close(modemfd);
		execl(_PATH_BSHELL, _PATH_BSHELL, "-c", cmd, NULL);
		warn("%s", _PATH_BSHELL);
		_exit(1);
	}
	waitpid(pid, &status, 0);
	return;
}
