/*	$Id: vox.h,v 1.3 1999/12/08 03:49:15 leonard Exp $	*/
/* Copyright 1999, David Leonard. All rights reserved. */

#define DLE	'\020'
#define ETX	'\003'
#define CAN	'\030'
#define SUB	'\032'

struct command {
	struct command *next;
	int srcline;
	char *srcname;
	enum { 
		CMD_ON_CLEAR,
		CMD_ON_STR,
		CMD_ON_TIMEOUT,
		CMD_LOCK,
		CMD_TIMER,
		CMD_QUOTE,
		CMD_WAIT,
		CMD_VCON,
		CMD_DELAY,
		CMD_GOTO,
		CMD_PLAY,
		CMD_RECORD,
		CMD_EXEC,
		CMD_SYSLOG,
		CMD_SETENV
	} action;
	union {
		struct	command *cmd;
		char *str;
	} dest;
	char	*string;
	int	onoff;
	int	number;
	char	*envvar;
};

extern int srcline;
extern char *srcname;
extern struct command *first;
extern char *modemdev;

extern int modemfd;

void    initlabels(void);
void    fix_dests(struct command *);
void	check_closure(struct command *);


void	print_escaped(FILE *, char *, size_t);
void	print_command(FILE *, struct command *);

int	yyparse();
int	yylex();
void	yyerror(char *);
