/*	$Id: vox_l.l,v 1.3 1999/12/08 03:49:26 leonard Exp $	*/
/* Copyright 1999, David Leonard. All rights reserved. */

%{
#include <stdio.h>
#include <string.h>
#include <err.h>
#include <stdlib.h>

#include "vox.h"
#include "y.tab.h"

char *	unescape(char *);
int	srcline;
char *	srcname;

%}


%%

#.*			/* comment */
\"(\\.|[^\\"])*\"	yylval.str = unescape(yytext); return STRING;
\'(\\.|[^\\'])*\'	yylval.str = unescape(yytext); return STRING;
[0-9][0-9]*		yylval.num = atoi(yytext); return NUMBER;
[ \t\f\r]*		/* whitespace */	
\n			srcline++; return '\n';
off			return OFF;
on			return ON;
dle			return DLEQ;
exec			return EXEC;
goto			return GOTO;
lock			return LOCK;
play			return PLAY;
vcon			return VCON;
wait			return WAIT;
clear			return CLEAR;
delay			return DELAY;
quote			return QUOTE;
timer			return TIMER;
record			return RECORD;
setenv			return SETENV;
syslog			return SYSLOG;
timeout			return TIMEOUT;
:			return ':';
[a-zA-Z_][a-zA-Z_0-9]+	yylval.str = strdup(yytext); return SYMBOL;
.			yyerror("lex error");

%%

char *
unescape(s)
	char *s;
{
	char *result, *u;

	result = (char *)malloc(strlen(s));
	if (result == NULL)
		err(1, "malloc");

	for (s++, u = result; *(s+1) != '\0'; s++) 
		if (*s != '\\') 
			*u++ = *s;
		else
			switch(*++s) {
			case 'n':	*u++ = '\n'; break;
			case 'r':	*u++ = '\r'; break;
			case 't':	*u++ = '\t'; break;
			case 'b':	*u++ = '\b'; break;
			case 'f':	*u++ = '\f'; break;
			case 'v':	*u++ = '\v'; break;
			default:	*u++ = *s;   break;
			}
	*u = '\0';
	return result;
}

int
yywrap()
{
	return 1;
}
